' MakeTrustedMHTML.VBS V1.01 (C) yoshioka.teruo@nifty.com 2006-06-04
' MakeTrustedMHTML.VBS makes MHTML file of trusted site from HTML file.
' Usage: Start MakeTrustedMHTML.VBS files...

Option Explicit
Const adSaveCreateOverWrite=2 
Dim TrustedSite
Dim fso
Dim arg
Dim File
Dim Path
Dim CDOMessage

TrustedSite=Empty
'TrustedSite="http://www.microsoft.com/"
If IsEmpty(TrustedSite) Then
  TrustedSite=InputBox("Enter URL of trusted site :",WScript.ScriptName,"https://www.mvpaward.com/")
End If
If TrustedSite="" Then WScript.Quit

Set fso=CreateObject("Scripting.FileSystemObject")

For Each arg In WScript.Arguments
  Set File=fso.GetFile(arg)
  Path=fso.BuildPath(fso.GetParentFolderName(File.Path),fso.GetBaseName(File.Name)&".mhtml")
  Set CDOMessage=CreateObject("CDO.Message") 
  CDOMessage.AutoGenerateTextBody=False
  CDOMessage.CreateMHTMLBody "file://"&File.Path
  Call MainBodyPart(CDOMessage.BodyPart,Empty)
  CDOMessage.GetStream.SaveToFile Path,adSaveCreateOverWrite
Next

Sub MainBodyPart(BodyPart,ByVal Base)
Dim SubBodyPart
Dim Fields
Dim Location

Set Fields=BodyPart.Fields
Location=Fields("urn:schemas:mailheader:content-location").Value
If Not IsEmpty(Location) Then Base=Location
Select Case BodyPart.ContentMediaType
Case "text/html"
  Select Case LCase(BodyPart.Charset)
  Case "shift_jis","x-sjis" BodyPart.ContentTransferEncoding="8bit"
'  Case Else BodyPart.ContentTransferEncoding="base64"
  End Select
  If Not IsEmpty(Base) Then
    Fields("urn:schemas:mailheader:content-base")=Base
  End If
  Fields("urn:schemas:mailheader:content-location")=TrustedSite
  Fields.Update
Case Else
  If Not IsEmpty(Base) Then
    Fields("urn:schemas:mailheader:content-base")=Base
    Fields("urn:schemas:mailheader:content-location")=TrustedSite
    Fields.Update
  End If
End Select
For Each SubBodyPart In BodyPart.BodyParts
  Call MainBodyPart(SubBodyPart,Base)
Next
End Sub
